;******************************************************************************
;
;	USART Functions
;
;	Version: September 9, 2009
;
;	Send usartByte via the USART.
;
;	Usart_TxHex - Display usartByte as two hex characters
;	Usart_TxChr - Display usartByte as a single character
;
;******************************************************************************

;******************************************************************************
;	USART - Transmit usartByte as two hex characters ("00" - "FF").
;******************************************************************************
Usart_TxHex:
	push	usartByte					; save register for low nibble conversion
	swap	usartByte					; convert the high nibble
	andi	usartByte,0x0F				; mask to keep just low nibble
	ori		usartByte,0x30				; add Ascii character prefix
	cpi		usartByte,0x3A				; test if 0 - 9 range
	brlt	UTxH_High					; yes, write it
	subi	usartByte,-7				; no, add 7 to get A - F range
UTxH_High:
	rcall	Usart_TxChr

	pop		usartByte					; convert the low nibble
	andi	usartByte,0x0F				; mask to keep just low nibble
	ori		usartByte,0x30				; add Ascii character prefix
	cpi		usartByte,0x3A				; test if 0 - 9 range
	brlt	UTxH_Low					; yes, write it
	subi	usartByte,-7				; no, add 7 to get A - F range
UTxH_Low:
	rcall	Usart_TxChr
	ret

;******************************************************************************
;	USART - Transmit usartByte
;******************************************************************************
Usart_TxChr:
	push	temp						; preserve temp
UTxC_Wait:
	lds		temp,UCSR1A
	sbrs 	temp,UDRE1					; wait for empty data register
	rjmp 	UTxC_Wait
	sts 	UDR1,usartByte
	pop		temp						; restore temp
	ret
